package schedframe.resources.computing.profiles.energy.power;

public class PState {

	protected String name;
	protected double frequency;
	protected double voltage;
	protected double powerUsage;
	protected double powerUsageMin;
	protected double powerUsageMax;

	/*public PState(PStateType name, double frequency, double voltage, double power) {
		super();
		this.name = name;
		this.frequency = frequency;
		this.voltage = voltage;
		this.power = power;
	}*/
	
	public String getName() {
		return name;
	}
	public double getFrequency() {
		return frequency;
	}
	public double getVoltage() {
		return voltage;
	}
	public double getPower() {
		if(powerUsage == 0)
			powerUsage = (powerUsageMin + powerUsageMax)/2;
		return powerUsage;
	}
	public double getPowerMin() {
		return powerUsageMin;
	}
	public double getPowerMax() {
		return powerUsageMax;
	}
	
	public static class Builder {
	  
		protected String name;
		protected double frequency;
		protected double voltage;
		protected double powerUsage;
		protected double powerUsageMin;
		protected double powerUsageMax;
		
		public Builder name(String name){this.name = name; return this; }
        public Builder frequency(double value){this.frequency = value; return this; }
        public Builder voltage(double value){this.voltage = value; return this; }
        public Builder powerUsage(double rate){this.powerUsage = rate; return this; }
        public Builder powerUsageMin(double rate){this.powerUsageMin = rate; return this; }
        public Builder powerUsageMax(double rate){this.powerUsageMax = rate; return this; }
        
        public PState build() {
            return new PState(this);
        }
	}
	
	private PState(Builder builder) {
		this.name = builder.name;
		this.frequency = builder.frequency;
		this.voltage = builder.voltage;
		this.powerUsage = builder.powerUsage;
		this.powerUsageMin = builder.powerUsageMin;
		this.powerUsageMax = builder.powerUsageMax;
	}
}
